<?php

class ModuleError extends AppModule
{
  var $OnError;
  var $ErrorHandler;

  function __construct(System $System)
  {
    parent::__construct($System);
    $this->Name = 'Error';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPLv3';
    $this->Description = 'Error logging and reporting';
    $this->Dependencies = array();

    $this->OnError = array();
    $this->ErrorHandler = new ErrorHandler();
    $this->ErrorHandler->OnError[] = array($this, 'DoError');
  }

  function DoStart()
  {
    if(isset($this->System->Config['Web']['ShowPHPError']))
      $this->ErrorHandler->ShowError = $this->System->Config['Web']['ShowPHPError'];
      else $this->ErrorHandler->ShowError = true;
    $this->ErrorHandler->Start();
  }

  function DoStop()
  {
    $this->ErrorHandler->Stop();
  }

  function DoError($Error)
  {
    foreach($this->OnError as $OnError)
      call_user_func($OnError, $Error);
  }
}
