local i=CzWoW_interface;
local n=CzWoW_interface_entoname;

local old_TutorialFrame_Update = TutorialFrame_Update;
local old_UIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;

local Translate=function(index)
  if i[index] then
    return(i[index])
  else
    return(getglobal(index))
  end  
end

local TranslateByText=function(text)
    if i[n[text]] then
      return(i[n[text]])
    else
      return(text)
    end
end

--error message in the middle screen
local function onEvent(self, event, ...)
	local arg1, arg2, arg3, arg4 = ...
	if(event == 'UI_ERROR_MESSAGE') then
		self:AddMessage(TranslateByText(arg1), 1.0, 0.1, 0.1, 1.0);
  else
    old_UIErrorsFrame_OnEvent(self, event, ...);
  end
end
UIErrorsFrame:SetScript('OnEvent', onEvent)

--tutotial works
TutorialFrame_Update=function(currentTutorial)
  old_TutorialFrame_Update(currentTutorial);
	local title = _G["TUTORIAL_TITLE"..currentTutorial];
	local text = _G["TUTORIAL"..currentTutorial];
	if ( title and text) then
		TutorialFrameTitle:SetText(TranslateByText(title));
		TutorialFrameText:SetText(TranslateByText(text));
	end
	TutorialFrame:SetHeight(TutorialFrameText:GetHeight() + 62);
end

--GameTooltipFrame begin
local oldTooltipSetText=GameTooltip["SetText"];
GameTooltip["SetText"]=function(object, text, r, g, b, alphaValue, textWrap)
		text=TranslateByText(text);
	oldTooltipSetText(object, text, r, g, b, alphaValue, textWrap);
end
--hooksecurefunc(GameTooltip, "SetText", print);


--Set global var with CZ texts
  for index, value in pairs(i) do
    if (i[index] == "") or (i[index] == getglobal(index)) or (string.find(index,"ERR") == 1) or (string.find(index,"SPELL_FAILED") == 1) then
    else 
      setglobal(index,i[index]);
    end
  end


--  for index, value in pairs(OptionsFrameSliders) do
--    value.text = TranslateByText(value.text);
    --value.tooltipText = TranslateByText(value.tooltipText);
--  end;
--OptionsFrame end


--  for index, value in pairs(SoundOptionsFrameSliders) do
--    value.text = TranslateByText(value.text);
    --value.tooltipText = TranslateByText(value.tooltipText);
--  end;
--SoundOptionsFrame end

  for index, value in pairs(uvarInfo) do
    --value.text =TranslateByText(value.text);
    value.event = TranslateByText(value.event);
  end;
--UI Options end



--ActionBarFrame.xml


--ActionButtonTemplate.xml


--AlertFrames.xml

--AchievementAlertFrameTemplateUnlocked:SetText(Translate("ACHIEVEMENT_UNLOCKED"));
--AchievementAlertFrameTemplateName:SetText(Translate("For the Alliance!"));

--AlternatePowerBar.xml


--AnimTimerFrame.xml


--ArenaFrame.xml

ArenaFrameFrameLabel:SetText(Translate("ARENA_BATTLES"));
ArenaFrameNameHeader:SetText(Translate("ARENA_RATED_BATTLE"));
ArenaFrameZoneDescription:SetText(Translate("ARENA_MASTER_TEXT"));
ArenaFrameNameHeader2:SetText(Translate("ARENA_PRACTICE_BATTLE"));
ArenaFrameCancelButton:SetText(Translate("CANCEL"));
ArenaFrameJoinButton:SetText(Translate("BATTLEFIELD_JOIN"));
ArenaFrameGroupJoinButton:SetText(Translate("BATTLEFIELD_GROUP_JOIN"));

--ArenaRegistrarFrame.xml

AvailableServicesText:SetText(Translate("ARENA_CHARTER_PURCHASE"));
RegistrationText:SetText(Translate("ARENA_CHARTER_TURN_IN"));
ArenaRegistrarFrameGoodbyeButton:SetText(Translate("CANCEL"));
ArenaRegistrarButton1:SetText(Translate("ARENA_TEAM_2V2"));
ArenaRegistrarButton2:SetText(Translate("ARENA_TEAM_3V3"));
ArenaRegistrarButton3:SetText(Translate("ARENA_TEAM_5V5"));
ArenaRegistrarButton4:SetText(Translate("ARENA_TEAM_2V2"));
ArenaRegistrarButton5:SetText(Translate("ARENA_TEAM_3V3"));
ArenaRegistrarButton6:SetText(Translate("ARENA_TEAM_5V5"));
ArenaRegistrarPurchaseText:SetText(Translate("ARENA_REGISTRAR_PURCHASE_TEXT"));
ArenaRegistrarCostLabel:SetText(Translate("COSTS_LABEL"));
ArenaRegistrarFrameCancelButton:SetText(Translate("CANCEL"));
ArenaRegistrarFramePurchaseButton:SetText(Translate("PURCHASE"));
PVPBannerFrameGreetingText:SetText(Translate("ARENA_BANNER_VENDOR_GREETING"));
PVPColorPickerButton1:SetText(Translate("EMBLEM_SYMBOL_COLOR"));
PVPColorPickerButton2:SetText(Translate("EMBLEM_BORDER_COLOR"));
PVPColorPickerButton3:SetText(Translate("EMBLEM_BACKGROUND"));
PVPBannerFrameCancelButton:SetText(Translate("CLOSE"));
PVPBannerFrameSaveButton:SetText(Translate("SAVE"));
PVPBannerFrameAcceptButton:SetText(Translate("ACCEPT"));
PVPBannerFrameCancelButton:SetText(Translate("CANCEL"));

--AudioOptionsFrame.xml

AudioOptionsFrameCancel:SetText(Translate("CANCEL"));
AudioOptionsFrameOkay:SetText(Translate("OKAY"));
AudioOptionsFrameDefaults:SetText(Translate("DEFAULTS"));

--AudioOptionsPanels.xml

AudioOptionsSoundPanelTitle:SetText(Translate("SOUND_LABEL"));
AudioOptionsSoundPanelSubText:SetText(Translate("SOUND_SUBTEXT"));
--AudioOptionsSoundPanelTitleSubTextEnableSoundPlaybackSoundEffectsErrorSpeechEmoteSoundsPetSoundsMusicLoopMusicAmbientSoundsSoundInBGReverbHRTFEnableDSPsSoundQualityHardwareHardwareDropDownLabel:SetText(Translate("GAME_SOUND_OUTPUT"));
--AudioOptionsSoundPanelTitleSubTextEnableSoundPlaybackSoundEffectsErrorSpeechEmoteSoundsPetSoundsMusicLoopMusicAmbientSoundsSoundInBGReverbHRTFEnableDSPsSoundQualityHardwareHardwareDropDownSoundChannelsUseHardwareVolumeMasterVolumeSoundVolumeLabel:SetText(Translate("SOUND_VOLUME"));
--AudioOptionsSoundPanelTitleSubTextEnableSoundPlaybackSoundEffectsErrorSpeechEmoteSoundsPetSoundsMusicLoopMusicAmbientSoundsSoundInBGReverbHRTFEnableDSPsSoundQualityHardwareHardwareDropDownSoundChannelsUseHardwareVolumeMasterVolumeSoundVolumeMusicVolumeLabel:SetText(Translate("MUSIC_VOLUME"));
--AudioOptionsSoundPanelTitleSubTextEnableSoundPlaybackSoundEffectsErrorSpeechEmoteSoundsPetSoundsMusicLoopMusicAmbientSoundsSoundInBGReverbHRTFEnableDSPsSoundQualityHardwareHardwareDropDownSoundChannelsUseHardwareVolumeMasterVolumeSoundVolumeMusicVolumeAmbienceVolumeLabel:SetText(Translate("AMBIENCE_VOLUME"));
AudioOptionsVoicePanelTitle:SetText(Translate("VOICE_LABEL"));
AudioOptionsVoicePanelSubText:SetText(Translate("VOICE_SUBTEXT"));
--AudioOptionsVoicePanelTitleSubTextDisabledMessageText:SetText(Translate("VOICECHAT_DISABLED"));
--AudioOptionsVoicePanelTitleSubTextDisabledMessageEnableVoiceTalkingEnableMicrophoneInputDeviceDropDownMicrophoneVolumeMicTestText:SetText(Translate("VOICE_MICROPHONE_TEST"));
--PlayLoopbackSoundButtonBindingChatModeDropDownLabel:SetText(Translate("VOICE_CHAT_MODE"));
--PlayLoopbackSoundButtonBindingChatModeDropDownChatMode1Label:SetText(Translate("KEY_BINDING"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownLabel:SetText(Translate("VOICE_CHAT_OUTPUT_DEVICE"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioLabel:SetText(Translate("VOICE_GAME_DUCKING"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioDescription:SetText(Translate("VOICE_CHAT_AUDIO_DUCKING"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioOff:SetText(Translate("OFF"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioNormal:SetText(Translate("VOICE_CHAT_NORMAL"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioSoundFadeLabel:SetText(Translate("SOUND_VOLUME"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioSoundFadeMusicFadeLabel:SetText(Translate("MUSIC_VOLUME"));
--AudioOptionsVoicePanelVoiceActivateSliderListeningOutputDeviceDropDownSpeakerVolumeAudioSoundFadeMusicFadeAmbienceFadeLabel:SetText(Translate("AMBIENCE_VOLUME"));

--AutoComplete.xml


--BankFrame.xml

BankFrameTitleText:SetText(Translate("ITEMSLOTTEXT"));
BankFrameTitleText:SetText(Translate("BAGSLOTTEXT"));
--BankFramePurchaseInfo:SetText(Translate("BANKSLOTPURCHASE_LABEL"));
BankFrameSlotCost:SetText(Translate("COSTS_LABEL"));
BankFramePurchaseButton:SetText(Translate("BANKSLOTPURCHASE"));

--BasicControls.xml

--DialogBoxFrameButtonButton:SetText(Translate("OKAY"));

--BattlefieldFrame.xml

BattlefieldFrameFrameLabel:SetText(Translate("BATTLEFIELDS"));
BattlefieldFrameNameHeader:SetText(Translate("BATTLEFIELD_NAME"));
BattlefieldFrameCancelButton:SetText(Translate("CANCEL"));
BattlefieldFrameJoinButton:SetText(Translate("BATTLEFIELD_JOIN"));
BattlefieldFrameGroupJoinButton:SetText(Translate("BATTLEFIELD_GROUP_JOIN"));

--Bindings.xml


--BonusActionBarFrame.xml


--BuffFrame.xml


--CastingBarFrame.xml


--ChannelFrame.xml

--ChannelRosterButtonTemplateName:SetText(Translate("Player Name"));
--ChannelFrameVerticalBarAutoJoinAutoJoin:SetText(Translate("VOICE_CHAT"));
ChannelFrameNewButton:SetText(Translate("ADD"));
--ChannelRosterChannelName:SetText(Translate("Channel Name"));
--ChannelMemberButton22DropDownDaughterFrameName:SetText(Translate("CHANNEL_NEW_CHANNEL"));
--ChannelMemberButton22DropDownDaughterFrameNameTitlebarCornerChannelNameLabel:SetText(Translate("CHANNEL_CHANNEL_NAME"));
--ChannelMemberButton22DropDownDaughterFrameNameTitlebarCornerChannelNameChannelPasswordLabel:SetText(Translate("PASSWORD"));
--ChannelMemberButton22DropDownDaughterFrameNameTitlebarCornerChannelNameChannelPasswordOptional:SetText(Translate("OPTIONAL_PARENS"));
--ChannelRosterDaughterFrameOkayButton:SetText(Translate("OKAY"));
--ChannelRosterDaughterFrameCancelButton:SetText(Translate("CANCEL"));
ChannelPulloutTabText:SetText(Translate("Channel Roster"));

--CharacterFrame.xml

CharacterNameText:SetText(Translate("NAME"));
CharacterFrameTab1:SetText(Translate("CHARACTER"));
CharacterFrameTab2:SetText(Translate("PETS"));
CharacterFrameTab3:SetText(Translate("REPUTATION"));
CharacterFrameTab4:SetText(Translate("SKILLS"));
CharacterFrameTab5:SetText(Translate("CURRENCY"));

--CharacterFrameTemplates.xml


--ChatConfigFrame.xml

--ChatConfigBoxWithHeaderAndClassColorsTemplateColorHeader:SetText(Translate("COLOR"));
--ChatConfigBoxWithHeaderAndClassColorsTemplateClassColorHeader:SetText(Translate("SHOW_CLASS_COLOR"));
--ClassColorLegendTemplateTitle:SetText(Translate("CLASS_COLORS"));
ChatConfigCategoryFrameTitle:SetText(Translate("CATEGORIES"));
ChatConfigCategoryFrameButton1:SetText(Translate("CHAT"));
ChatConfigCategoryFrameButton2:SetText(Translate("COMBAT"));
ChatConfigCategoryFrameButton3:SetText(Translate("GLOBAL_CHANNELS"));
ChatConfigCategoryFrameButton4:SetText(Translate("OTHER"));
--ChatConfigCombatSettings:SetText(Translate("FILTERS"));
ChatConfigCombatSettingsFiltersDeleteButton:SetText(Translate("DELETE"));
ChatConfigCombatSettingsFiltersAddFilterButton:SetText(Translate("ADD_FILTER"));
ChatConfigCombatSettingsFiltersCopyFilterButton:SetText(Translate("COPY_FILTER"));
--CombatConfigMessageTypesLeftRightMiscMisc:SetText(Translate("MISCELLANEOUS"));
CombatConfigColorsExampleTitle:SetText(Translate("EXAMPLE_TEXT"));
--CombatConfigColorsExampleString1ExampleString2ExampleTitleUnitColorsHighlightingTitle:SetText(Translate("HIGHLIGHTING"));
--CombatConfigColorsExampleString1ExampleString2ExampleTitleUnitColorsHighlightingTitleLineAbilityDamageSchoolColorizeUnitNameUnitName:SetText(Translate("COLORIZE"));
CombatConfigFormattingExampleTitle:SetText(Translate("EXAMPLE_TEXT"));
--CombatConfigSettingsNameEditBoxNameEditBox:SetText(Translate("FILTER_NAME"));
CombatConfigSettingsSaveButton:SetText(Translate("SAVE"));
ChatConfigFrameDefaultButton:SetText(Translate("CHAT_DEFAULTS"));
CombatLogDefaultButton:SetText(Translate("COMBATLOG_DEFAULTS"));
ChatConfigFrameCancelButton:SetText(Translate("CANCEL"));
ChatConfigFrameOkayButton:SetText(Translate("OKAY"));

--ChatFrame.xml


--CinematicFrame.xml


--ClassTrainerFrameTemplates.xml


--CoinPickupFrame.xml

CoinPickupLabel:SetText(Translate("COPPER_AMOUNT_SYMBOL"));
CoinPickupOkayButton:SetText(Translate("OKAY"));
CoinPickupCancelButton:SetText(Translate("COINPICKUP_CANCEL"));

--ColorPickerFrame.xml

--ColorPickerFrameHeader:SetText(Translate("COLOR_PICKER"));
ColorPickerCancelButton:SetText(Translate("CANCEL"));
ColorPickerOkayButton:SetText(Translate("OKAY"));
OpacitySliderFrameText:SetText(Translate("0%"));
OpacitySliderFrameText:SetText(Translate("100%"));
OpacityFrameSliderText:SetText(Translate("OPACITY"));
OpacityFrameSliderText:SetText(Translate("0%"));
OpacityFrameSliderText:SetText(Translate("100%"));

--CombatFeedback.xml


--ComboFrame.xml


--ContainerFrame.xml


--Cooldown.xml


--DressUpFrame.xml

DressUpFrameTitleText:SetText(Translate("DRESSUP_FRAME"));
DressUpFrameDescriptionText:SetText(Translate("DRESSUP_FRAME_INSTRUCTIONS"));
DressUpFrameCancelButton:SetText(Translate("CLOSE"));
DressUpFrameResetButton:SetText(Translate("RESET"));

--DurabilityFrame.xml


--FadingFrame.xml


--FloatingChatFrame.xml


--FocusFrame.xml

FocusFrameNumericalThreatValue:SetText(Translate("100%"));
TargetofFocusDeadText:SetText(Translate("DEAD"));

--FontStyles.xml


--Fonts.xml


--FriendsFrame.xml

FriendsFrameToggleTab1:SetText(Translate("FRIENDS"));
FriendsFrameToggleTab2:SetText(Translate("IGNORE"));
FriendsFrameToggleTab3:SetText(Translate("MUTED"));
FriendsFrameAddFriendButton:SetText(Translate("ADD_FRIEND"));
FriendsFrameRemoveFriendButton:SetText(Translate("REMOVE_FRIEND"));
FriendsFrameSendMessageButton:SetText(Translate("SEND_MESSAGE"));
FriendsFrameGroupInviteButton:SetText(Translate("GROUP_INVITE"));
IgnoreFrameToggleTab1:SetText(Translate("FRIENDS"));
IgnoreFrameToggleTab2:SetText(Translate("IGNORE"));
IgnoreFrameToggleTab3:SetText(Translate("MUTED"));
FriendsFrameIgnorePlayerButton:SetText(Translate("IGNORE_PLAYER"));
FriendsFrameStopIgnoreButton:SetText(Translate("STOP_IGNORE"));
MutedFrameToggleTab1:SetText(Translate("FRIENDS"));
MutedFrameToggleTab2:SetText(Translate("IGNORE"));
MutedFrameToggleTab3:SetText(Translate("MUTED"));
FriendsFrameMutedPlayerButton:SetText(Translate("MUTE_PLAYER"));
FriendsFrameUnmuteButton:SetText(Translate("UNMUTE"));
WhoFrameColumnHeader1:SetText(Translate("NAME"));
WhoFrameColumnHeader3:SetText(Translate("LEVEL_ABBR"));
WhoFrameColumnHeader4:SetText(Translate("CLASS"));
WhoFrameGroupInviteButton:SetText(Translate("GROUP_INVITE"));
WhoFrameAddFriendButton:SetText(Translate("ADD_FRIEND"));
WhoFrameWhoButton:SetText(Translate("REFRESH"));
GuildFrameNotesLabel:SetText(Translate("GUILD_MOTD_LABEL"));
GuildFrameLFGButtonText:SetText(Translate("SHOW_OFFLINE_MEMBERS"));
GuildFrameColumnHeader1:SetText(Translate("NAME"));
GuildFrameColumnHeader2:SetText(Translate("ZONE"));
GuildFrameColumnHeader3:SetText(Translate("LEVEL_ABBR"));
GuildFrameColumnHeader4:SetText(Translate("CLASS"));
GuildFrameGuildStatusColumnHeader1:SetText(Translate("NAME"));
GuildFrameGuildStatusColumnHeader2:SetText(Translate("RANK"));
GuildFrameGuildStatusColumnHeader3:SetText(Translate("LABEL_NOTE"));
GuildFrameGuildStatusColumnHeader4:SetText(Translate("LASTONLINE"));
GuildFrameControlButton:SetText(Translate("GUILDCONTROL"));
GuildFrameAddMemberButton:SetText(Translate("ADDMEMBER"));
GuildFrameGuildInformationButton:SetText(Translate("GUILD_INFORMATION"));
--GuildControlPopupFrame:SetText(Translate("GUILDCONTROL_SELECTRANK"));
--GuildControlPopupFrame:SetText(Translate("GUILDCONTROL_ALLOWRANK"));
GuildControlWithdrawGoldText:SetText(Translate("GUILDCONTROL_WITHDRAW_GOLD"));
GuildControlWithdrawGoldAmountText:SetText(Translate("GOLD_PER_DAY"));
GuildControlPopupFrameCancelButton:SetText(Translate("CANCEL"));
GuildControlPopupAcceptButton:SetText(Translate("ACCEPT"));
GuildControlPopupFrameEditBox:SetText(Translate("GUILDCONTROL_RANKLABEL"));
GuildBankTabLabel:SetText(Translate("GUILDBANK_TAB_COLON"));
GuildControlTabPermissionsWithdrawItemsText:SetText(Translate("GUILDCONTROL_WITHDRAW_ITEMS"));
GuildBankTabPermissionsTab6:SetText(Translate("6"));
GuildBankTabPermissionsTab5:SetText(Translate("5"));
GuildBankTabPermissionsTab4:SetText(Translate("4"));
GuildBankTabPermissionsTab3:SetText(Translate("3"));
GuildBankTabPermissionsTab2:SetText(Translate("2"));
GuildBankTabPermissionsTab1:SetText(Translate("1"));
GuildInfoTitle:SetText(Translate("GUILD_INFORMATION"));
GuildInfoSaveButton:SetText(Translate("ACCEPT"));
GuildInfoCancelButton:SetText(Translate("CLOSE"));
GuildInfoGuildEventButton:SetText(Translate("GUILD_EVENT_LOG"));
GuildMemberDetailZoneLabel:SetText(Translate("ZONE_COLON"));
GuildMemberDetailRankLabel:SetText(Translate("RANK_COLON"));
GuildMemberDetailOnlineLabel:SetText(Translate("LAST_ONLINE_COLON"));
GuildMemberDetailNoteLabel:SetText(Translate("NOTE_COLON"));
GuildMemberDetailOfficerNoteLabel:SetText(Translate("OFFICER_NOTE_COLON"));
GuildMemberRemoveButton:SetText(Translate("REMOVE"));
GuildMemberGroupInviteButton:SetText(Translate("GROUP_INVITE"));
GuildEventLogTitle:SetText(Translate("GUILD_EVENT_LOG"));
GuildEventLogCancelButton:SetText(Translate("CLOSE"));
FriendsFrameTab1:SetText(Translate("FRIENDS"));
FriendsFrameTab2:SetText(Translate("WHO"));
FriendsFrameTab3:SetText(Translate("GUILD"));
FriendsFrameTab4:SetText(Translate("CHAT"));
FriendsFrameTab5:SetText(Translate("RAID"));

--GameMenuFrame.xml

--GameMenuFrameHeader:SetText(Translate("MAIN_MENU"));
GameMenuButtonOptions:SetText(Translate("VIDEOOPTIONS_MENU"));
--GameMenuButtonSoundOptions:SetText(Translate("SOUNDOPTIONS_MENU"));
GameMenuButtonUIOptions:SetText(Translate("UIOPTIONS_MENU"));
GameMenuButtonMacOptions:SetText(Translate("MAC_OPTIONS"));
GameMenuButtonKeybindings:SetText(Translate("KEY_BINDINGS"));
GameMenuButtonMacros:SetText(Translate("MACROS"));
GameMenuButtonRatings:SetText(Translate("RATINGS_MENU"));
GameMenuButtonLogout:SetText(Translate("LOGOUT"));
GameMenuButtonQuit:SetText(Translate("EXIT_GAME"));
GameMenuButtonContinue:SetText(Translate("RETURN_TO_GAME"));

--GameTime.xml


--GameTooltip.xml


--GameTooltipTemplate.xml


--GossipFrame.xml

GossipFrameGreetingGoodbyeButton:SetText(Translate("GOODBYE"));
GossipGreetingText:SetText(Translate("Filler Text"));

--GuildRegistrarFrame.xml

AvailableServicesText:SetText(Translate("AVAILABLE_SERVICES"));
GuildRegistrarFrameGoodbyeButton:SetText(Translate("CANCEL"));
GuildRegistrarButton1:SetText(Translate("GUILD_CHARTER_PURCHASE"));
GuildRegistrarButton2:SetText(Translate("GUILD_CHARTER_REGISTER"));
GuildRegistrarPurchaseText:SetText(Translate("GUILD_REGISTRAR_PURCHASE_TEXT"));
GuildRegistrarCostLabel:SetText(Translate("COSTS_LABEL"));
GuildRegistrarFrameCancelButton:SetText(Translate("CANCEL"));
GuildRegistrarFramePurchaseButton:SetText(Translate("PURCHASE"));

--HelpFrame.xml

--HelpFrameCancelButtonTemplate:SetText(Translate("CANCEL"));
--HelpFrameHeader:SetText(Translate("HELP_FRAME_TITLE"));
HelpFrameGMTalkTitle:SetText(Translate("HELPFRAME_GMTALK_TITLE"));
HelpFrameGMTalkText1:SetText(Translate("HELPFRAME_GMTALK_TEXT1"));
HelpFrameGMTalkIssue1Header:SetText(Translate("HELPFRAME_GMTALK_ISSUE1_HEADER"));
HelpFrameGMTalkIssue1:SetText(Translate("HELPFRAME_GMTALK_ISSUE1"));
HelpFrameGMTalkIssue2Header:SetText(Translate("HELPFRAME_GMTALK_ISSUE2_HEADER"));
HelpFrameGMTalkIssue2:SetText(Translate("HELPFRAME_GMTALK_ISSUE2"));
HelpFrameGMTalkIssue3Header:SetText(Translate("HELPFRAME_GMTALK_ISSUE3_HEADER"));
HelpFrameGMTalkIssue3:SetText(Translate("HELPFRAME_GMTALK_ISSUE3"));
HelpFrameGMTalkPvpPolicyUrl:SetText(Translate("PVP_POLICY_URL"));
HelpFrameGMTalkText2:SetText(Translate("HELPFRAME_GMTALK_TEXT2"));
HelpFrameGMTalkOpenTicket:SetText(Translate("HELP_TICKET_OPEN"));
HelpFrameReportIssueTitle:SetText(Translate("HELPFRAME_REPORTISSUE_TITLE"));
HelpFrameReportIssueText1:SetText(Translate("HELPFRAME_REPORTISSUE_TEXT1"));
HelpFrameReportIssueBulletTitle1:SetText(Translate("HELPFRAME_REPORTISSUE_BULLET_TITLE1"));
HelpFrameReportIssueText2:SetText(Translate("HELPFRAME_REPORTISSUE_TEXT2"));
HelpFrameReportIssueOpenTicket:SetText(Translate("HELP_TICKET_OPEN"));
HelpFrameStuckTitle:SetText(Translate("HELPFRAME_STUCK_TITLE"));
HelpFrameStuckText1:SetText(Translate("HELPFRAME_STUCK_TEXT1"));
HelpFrameStuckStuck:SetText(Translate("STUCK_BUTTON_TEXT"));
HelpFrameStuckOpenTicket:SetText(Translate("HELP_TICKET_OPEN"));
HelpFrameOpenTicketLabel:SetText(Translate("HELPFRAME_OPENTICKET_TEXT"));
HelpFrameOpenTicketCancel:SetText(Translate("CANCEL"));
HelpFrameOpenTicketSubmit:SetText(Translate("SUBMIT"));
HelpFrameViewResponseIssueHeader:SetText(Translate("GM_RESPONSE_ISSUE_HEADER"));
HelpFrameViewResponseMessageHeader:SetText(Translate("GM_RESPONSE_MESSAGE_HEADER"));
HelpFrameViewResponseMoreHelp:SetText(Translate("GM_RESPONSE_MORE_HELP"));
HelpFrameViewResponseIssueResolved:SetText(Translate("GM_RESPONSE_RESOLVE"));
HelpFrameWelcomeTitle:SetText(Translate("HELPFRAME_WELCOME_TITLE"));
HelpFrameWelcomeText1:SetText(Translate("HELPFRAME_WELCOME_TEXT1"));
HelpFrameWelcomeGMTalk:SetText(Translate("KBASE_GMTALK"));
HelpFrameWelcomeReportIssue:SetText(Translate("KBASE_REPORTISSUE"));
HelpFrameWelcomeStuck:SetText(Translate("KBASE_CHARSTUCK"));

--HonorFrame.xml

HonorLevelText:SetText(Translate("Level level race class"));
HonorFrameCurrentSessionTitle:SetText(Translate("HONOR_THIS_SESSION"));
HonorFrameYesterdayTitle:SetText(Translate("HONOR_YESTERDAY"));
HonorFrameThisWeekTitle:SetText(Translate("HONOR_THISWEEK"));
HonorFrameLastWeekTitle:SetText(Translate("HONOR_LASTWEEK"));
HonorFrameLifeTimeTitle:SetText(Translate("HONOR_LIFETIME"));

--HonorFrameTemplates.xml

--HonorFrameHKButtonTemplateText:SetText(Translate("HONORABLE_KILLS"));
--HonorFrameDKButtonTemplateText:SetText(Translate("DISHONORABLE_KILLS"));
--HonorFrameContributionButtonTemplateText:SetText(Translate("HONOR_CONTRIBUTION_POINTS"));
--HonorFrameStandingButtonTemplateText:SetText(Translate("HONOR_STANDING"));
--HonorFrameRankButtonTemplateText:SetText(Translate("HONOR_HIGHEST_RANK"));

--HybridScrollFrame.xml


--InterfaceOptionsFrame.xml

InterfaceOptionsFrameHeaderText:SetText(Translate("UIOPTIONS_MENU"));
InterfaceOptionsFrameCancel:SetText(Translate("CANCEL"));
InterfaceOptionsFrameOkay:SetText(Translate("OKAY"));
InterfaceOptionsFrameDefaults:SetText(Translate("DEFAULTS"));
InterfaceOptionsFrameTab1:SetText(Translate("GAME"));
InterfaceOptionsFrameTab2:SetText(Translate("ADDONS"));

--InterfaceOptionsPanels.xml

InterfaceOptionsControlsPanelTitle:SetText(Translate("CONTROLS_LABEL"));
InterfaceOptionsControlsPanelSubText:SetText(Translate("CONTROLS_SUBTEXT"));
--InterfaceOptionsControlsPanelTitleSubTextStickyTargetingAutoDismountAutoClearAFKBlockTradesLootAtMouseAutoLootCorpseAutoLootKeyDropDownLabel:SetText(Translate("AUTO_LOOT_KEY_TEXT"));
InterfaceOptionsCombatPanelTitle:SetText(Translate("COMBAT_LABEL"));
InterfaceOptionsCombatPanelSubText:SetText(Translate("COMBAT_SUBTEXT"));
--InterfaceOptionsCombatPanelTitleSubTextAttackOnAssistAutoRangeStopAutoAttackNameplateClassColorsAutoSelfCastSelfCastKeyDropDownLabel:SetText(Translate("AUTO_SELF_CAST_KEY_TEXT"));
--InterfaceOptionsCombatPanelTitleSubTextAttackOnAssistAutoRangeStopAutoAttackNameplateClassColorsAutoSelfCastSelfCastKeyDropDownEnemyCastBarsLabel:SetText(Translate("SHOW_ENEMY_CAST"));
--InterfaceOptionsCombatPanelTitleSubTextAttackOnAssistAutoRangeStopAutoAttackNameplateClassColorsAutoSelfCastSelfCastKeyDropDownEnemyCastBarsOnPortraitOnNameplatesTargetOfTargetTOTDropDownFocusCastKeyDropDownLabel:SetText(Translate("FOCUS_CAST_KEY_TEXT"));
InterfaceOptionsDisplayPanelTitle:SetText(Translate("DISPLAY_LABEL"));
InterfaceOptionsDisplayPanelSubText:SetText(Translate("DISPLAY_SUBTEXT"));
--InterfaceOptionsDisplayPanelTitleSubTextShowCloakShowHelmBuffDurationsRotateMinimapScreenEdgeFlashDetailedLootInfoShowFreeBagSpaceShowClockAggroWarningDisplayLabel:SetText(Translate("AGGRO_WARNING_DISPLAY"));
--InterfaceOptionsDisplayPanelTitleSubTextShowCloakShowHelmBuffDurationsRotateMinimapScreenEdgeFlashDetailedLootInfoShowFreeBagSpaceShowClockAggroWarningDisplayShowAggroPercentageColorblindModeShowItemLevelWorldPVPObjectiveDisplayLabel:SetText(Translate("WORLD_PVP_DISPLAY"));
InterfaceOptionsObjectivesPanelTitle:SetText(Translate("OBJECTIVES_TRACKER_LABEL"));
InterfaceOptionsObjectivesPanelSubText:SetText(Translate("OBJECTIVES_SUBTEXT"));
InterfaceOptionsSocialPanelTitle:SetText(Translate("SOCIAL_LABEL"));
InterfaceOptionsSocialPanelSubText:SetText(Translate("SOCIAL_SUBTEXT"));
InterfaceOptionsActionBarsPanelTitle:SetText(Translate("ACTIONBARS_LABEL"));
InterfaceOptionsActionBarsPanelSubText:SetText(Translate("ACTIONBARS_SUBTEXT"));
InterfaceOptionsNamesPanelTitle:SetText(Translate("NAMES_LABEL"));
InterfaceOptionsNamesPanelSubText:SetText(Translate("NAMES_SUBTEXT"));
InterfaceOptionsCombatTextPanelTitle:SetText(Translate("COMBATTEXT_LABEL"));
InterfaceOptionsCombatTextPanelSubText:SetText(Translate("COMBATTEXT_SUBTEXT"));
--InterfaceOptionsCombatTextPanelTitleSubTextTargetDamagePeriodicDamagePetDamageHealingTargetEffectsOtherTargetEffectsEnableFCTFCTDropDownLabel:SetText(Translate("MODE"));
InterfaceOptionsStatusTextPanelTitle:SetText(Translate("STATUSTEXT_LABEL"));
InterfaceOptionsStatusTextPanelSubText:SetText(Translate("STATUSTEXT_SUBTEXT"));
InterfaceOptionsUnitFramePanelTitle:SetText(Translate("UNITFRAME_LABEL"));
InterfaceOptionsUnitFramePanelSubText:SetText(Translate("UNITFRAME_SUBTEXT"));
InterfaceOptionsCameraPanelTitle:SetText(Translate("CAMERA_LABEL"));
InterfaceOptionsCameraPanelSubText:SetText(Translate("CAMERA_SUBTEXT"));
--InterfaceOptionsCameraPanelTitleSubTextStyleDropDownLabel:SetText(Translate("CAMERA_FOLLOWING_STYLE"));
InterfaceOptionsMousePanelTitle:SetText(Translate("MOUSE_LABEL"));
InterfaceOptionsMousePanelSubText:SetText(Translate("MOUSE_SUBTEXT"));
--InterfaceOptionsMousePanelTitleSubTextInvertMouseClickToMoveMouseSensitivitySliderMouseLookSpeedSliderClickMoveStyleDropDownLabel:SetText(Translate("CLICK_CAMERA_STYLE"));
InterfaceOptionsFeaturesPanelTitle:SetText(Translate("FEATURES_LABEL"));
InterfaceOptionsFeaturesPanelSubText:SetText(Translate("FEATURES_SUBTEXT"));
--InterfaceOptionsFeaturesPanelTitleSubTextEquipmentManagerDescription:SetText(Translate("OPTION_USE_EQUIPMENT_MANAGER_DESCRIPTION"));
--InterfaceOptionsFeaturesPanelTitleSubTextEquipmentManagerPreviewTalentChangesDescription:SetText(Translate("OPTION_PREVIEW_TALENT_CHANGES_DESCRIPTION"));
InterfaceOptionsHelpPanelTitle:SetText(Translate("HELP_LABEL"));
InterfaceOptionsHelpPanelSubText:SetText(Translate("HELP_SUBTEXT"));
InterfaceOptionsHelpPanelResetTutorials:SetText(Translate("RESET_TUTORIALS"));
InterfaceOptionsLanguagesPanelTitle:SetText(Translate("LANGUAGES_LABEL"));
InterfaceOptionsLanguagesPanelSubText:SetText(Translate("LANGUAGES_SUBTEXT"));
--InterfaceOptionsLanguagesPanelTitleSubTextLocaleDropDownLabel:SetText(Translate("LOCALE_INFORMATION"));

--ItemButtonTemplate.xml


--ItemRef.xml


--ItemTextFrame.xml

ItemTextPrevPageButton:SetText(Translate("PREV"));
ItemTextNextPageButton:SetText(Translate("NEXT"));

--KnowledgeBaseFrame.xml

--KnowledgeBaseFrameHeader:SetText(Translate("KNOWLEDGEBASE_FRAME_TITLE"));
KnowledgeBaseMotdLabel:SetText(Translate("MOTD_COLON"));
KnowledgeBaseServerMessageLabel:SetText(Translate("SERVER_MESSAGE_COLON"));
KnowledgeBaseFrameTopIssuesButton:SetText(Translate("KBASE_TOP_ISSUES"));
GMChatOpenLog:SetText(Translate("GM_CHAT_OPEN"));
KnowledgeBaseFrameSearchButton:SetText(Translate("SEARCH"));
KnowledgeBaseArticleListFrameTitle:SetText(Translate("KBASE_TOP_ISSUES"));
KnowledgeBaseArticleListFrameCount:SetText(Translate("ARTICLE_COUNT"));
KnowledgeBaseArticleListFrameNextButtonText:SetText(Translate("NEXT"));
KnowledgeBaseArticleListFramePreviousButtonText:SetText(Translate("PREVIOUS"));
KnowledgeBaseArticleScrollChildFrameBackButton:SetText(Translate("BACK"));
KnowledgeBaseErrorFrameText:SetText(Translate("ERROR"));
KnowledgeBaseFrameGMTalk:SetText(Translate("KBASE_GMTALK"));
KnowledgeBaseFrameReportIssue:SetText(Translate("KBASE_REPORTISSUE"));
KnowledgeBaseFrameStuck:SetText(Translate("KBASE_CHARSTUCK"));
KnowledgeBaseFrameEditTicket:SetText(Translate("HELP_TICKET_EDIT"));
KnowledgeBaseFrameAbandonTicket:SetText(Translate("HELP_TICKET_ABANDON"));

--LFGFrame.xml

LFGParentFrameTitle:SetText(Translate("LFM_TITLE"));
LFMFrameColumnHeader2:SetText(Translate("LEVEL_ABBR"));
LFMFrameColumnHeader3:SetText(Translate("CLASS"));
LFMFrameColumnHeader4Group:SetText(Translate("PLAYERS_IN_GROUP"));
LFMFrameGroupInviteButton:SetText(Translate("GROUP_INVITE"));
LFMFrameSendMessageButton:SetText(Translate("SEND_MESSAGE"));
LFMFrameCommentButton:SetText(Translate("COMMENT"));
LFGRolesLabel:SetText(Translate("LFG_ROLES_TITLE"));
LFGLabel1:SetText(Translate("LOOKING_FOR_GROUP_LABEL"));
LFGLabel2:SetText(Translate("LOOKING_FOR_GROUP_LABEL2"));
LFGLabel3:SetText(Translate("LOOKING_FOR_GROUP_LABEL2"));
LFGFrameRoleButton1Label:SetText(Translate("DAMAGER"));
LFGFrameRoleButton2Label:SetText(Translate("TANK"));
LFGFrameRoleButton3Label:SetText(Translate("HEALER"));
LFGFrameDoneButton:SetText(Translate("CLOSE"));
LFGFrameClearAllButton:SetText(Translate("LEAVE_ALL"));
LFGFrameCommentButton:SetText(Translate("COMMENT"));
LFGFrameNoRoleBackgroundLabel:SetText(Translate("NO_ROLE_SELECTED"));
LFGParentFrameTab1:SetText(Translate("LFG_TITLE"));
LFGParentFrameTab2:SetText(Translate("LFM_TITLE"));

--Localization.xml


--LocalizationPost.xml


--LootFrame.xml

--LootFramePortraitOverlay:SetText(Translate("ITEMS"));
LootFramePrev:SetText(Translate("PREV"));
LootFrameNext:SetText(Translate("NEXT"));
--GroupLootFrameTemplateName:SetText(Translate("Item Name"));

--MacOptionsFrame.xml

--MacOptionsFrameHeader:SetText(Translate("MAC_OPTIONS"));
MacOptionsFrameResolutionDropDownLabel:SetText(Translate("RESOLUTION"));
MacOptionsFrameFramerateDropDownLabel:SetText(Translate("MOVIE_RECORDING_FRAMERATE"));
MacOptionsFrameCodecDropDownLabel:SetText(Translate("MOVIE_RECORDING_COMPRESSION"));
MacOptionsButtonCompress:SetText(Translate("MOVIE_RECORDING_COMPRESSDIALOG"));
MacOptionsFrameText1:SetText(Translate("MOVIE_RECORDING_TIME"));
MacOptionsFrameText2:SetText(Translate("00:00:00"));
MacOptionsFrameText3:SetText(Translate("MOVIE_RECORDING_DATA_RATE"));
MacOptionsFrameCancel:SetText(Translate("CANCEL"));
MacOptionsFrameOkay:SetText(Translate("OKAY"));
MacOptionsFrameDefaults:SetText(Translate("DEFAULTS"));
MacOptionsButtonKeybindings:SetText(Translate("KEY_BINDINGS_MAC"));
--MacOptionsCompressFrameHeader:SetText(Translate("MOVIE_RECORDING_COMPRESSDIALOG"));
MacOptionsCompressFrameDelete:SetText(Translate("DELETE"));
MacOptionsCompressFrameSkip:SetText(Translate("IGNORE_DIALOG"));
MacOptionsCompressFrameCompress:SetText(Translate("MOVIE_RECORDING_COMPRESSBUTTON"));
--MacOptionsCancelFrameHeader:SetText(Translate("CANCEL"));
--MacOptionsCancelFrameQuestion:SetText(Translate("MOVIE_RECORDING_CANCEL_CONFIRMATION"));
MacOptionsCancelFrameNo:SetText(Translate("NO"));
MacOptionsCancelFrameYes:SetText(Translate("YES"));
--FolderPickerHeader:SetText(Translate("Folder..."));
FolderPickerButton01:SetText(Translate("YES"));
FolderPickerButton01Name:SetText(Translate("Player Name"));

--MailFrame.xml

--MailItemTemplateSenderSubjectExpireTimeButtonCOD:SetText(Translate("CASH_ON_DELIVERY"));
InboxTitleText:SetText(Translate("INBOX"));
InboxTooMuchMail:SetText(Translate("INBOX_TOO_MUCH_MAIL"));
InboxPrevPageButton:SetText(Translate("PREV"));
InboxNextPageButton:SetText(Translate("NEXT"));
SendMailTitleText:SetText(Translate("SENDMAIL"));
SendMailNameEditBox:SetText(Translate("MAIL_TO_LABEL"));
--SendMailCostMoneyFrame:SetText(Translate("SEND_MAIL_COST"));
SendMailSubjectEditBox:SetText(Translate("MAIL_SUBJECT_LABEL"));
SendMailMoneyText:SetText(Translate("SEND_MONEY"));
SendMailCancelButton:SetText(Translate("CANCEL"));
SendMailMailButton:SetText(Translate("SEND_LABEL"));
MailFrameTab1:SetText(Translate("INBOX"));
MailFrameTab2:SetText(Translate("SENDMAIL"));
--StationeryPopupFrame:SetText(Translate("CHOOSE_STATIONERY"));
StationeryPopupCancelButton:SetText(Translate("CANCEL"));
StationeryPopupOkayButton:SetText(Translate("OKAY"));
OpenMailTitleText:SetText(Translate("OPENMAIL"));
OpenMailAttachmentText:SetText(Translate("TAKE_ATTACHMENTS"));
OpenMailSenderLabel:SetText(Translate("FROM"));
OpenMailSubjectLabel:SetText(Translate("MAIL_SUBJECT_LABEL"));
OpenMailReportSpamButton:SetText(Translate("REPORT_SPAM"));
OpenMailInvoiceItemLabel:SetText(Translate("ITEM_SOLD_COLON"));
OpenMailInvoicePurchaser:SetText(Translate("PURCHASED_BY_COLON"));
OpenMailInvoiceSalePrice:SetText(Translate("SALE_PRICE_COLON"));
OpenMailInvoiceDeposit:SetText(Translate("DEPOSIT_COLON"));
OpenMailInvoiceHouseCut:SetText(Translate("AUCTION_HOUSE_CUT_COLON"));
OpenMailInvoiceAmountReceived:SetText(Translate("AMOUNT_RECEIVED_COLON"));
OpenMailInvoiceNotYetSent:SetText(Translate("AUCTION_INVOICE_FUNDS_NOT_YET_SENT"));
--OpenMailDepositMoneyFrame:SetText(Translate("+"));
--OpenMailHouseCutMoneyFrame:SetText(Translate("-"));
OpenMailCancelButton:SetText(Translate("CLOSE"));
OpenMailDeleteButton:SetText(Translate("DELETE"));
OpenMailReplyButton:SetText(Translate("REPLY_MESSAGE"));

--MainMenuBar.xml


--MainMenuBarBagButtons.xml


--MainMenuBarMicroButtons.xml


--MerchantFrame.xml

--MerchantItemTemplateName:SetText(Translate("Item Name"));
MerchantNameText:SetText(Translate("Merchant Name"));
MerchantPageText:SetText(Translate("Page"));
MerchantRepairText:SetText(Translate("REPAIR_ITEMS"));
MerchantBuyBackItemName:SetText(Translate("Item Name"));
MerchantPrevPageButton:SetText(Translate("PREV"));
MerchantNextPageButton:SetText(Translate("NEXT"));
MerchantFrameTab1:SetText(Translate("MERCHANT"));
MerchantFrameTab2:SetText(Translate("BUYBACK"));

--MinigameFrame.xml


--Minimap.xml


--MirrorTimer.xml


--MoneyFrame.xml


--MoneyInputFrame.xml

--MoneyInputFrameTemplateGoldMiddle:SetText(Translate("GOLD_AMOUNT_SYMBOL"));
--MoneyInputFrameTemplateGoldSilverMiddle:SetText(Translate("SILVER_AMOUNT_SYMBOL"));
--MoneyInputFrameTemplateGoldSilverCopperMiddle:SetText(Translate("COPPER_AMOUNT_SYMBOL"));

--MovieFrame.xml


--MovieRecordingProgress.xml

MovieProgressBarText:SetText(Translate("Compressing"));

--MultiActionBars.xml


--MultiCastActionBarFrame.xml


--OpacitySliderFrame.xml

OpacitySliderFrameText:SetText(Translate("LOW"));
OpacitySliderFrameText:SetText(Translate("HIGH"));

--OptionsFrameTemplates.xml

--OptionsFrameTemplateHeaderText:SetText(Translate("OPTIONS"));

--OptionsPanelTemplates.xml

--OptionsSliderTemplateLow:SetText(Translate("LOW"));
--OptionsSliderTemplateHigh:SetText(Translate("HIGH"));

--PVPBattlegroundFrame.xml

PVPBattlegroundFrameFrameLabel:SetText(Translate("BATTLEGROUNDS"));
PVPBattlegroundFrameNameHeader:SetText(Translate("BATTLEGROUND"));
PVPBattlegroundFrameZoneDescription:SetText(Translate("BATTLEGROUND_LORETEXT_1"));
PVPBattlegroundFrameNameHeader2:SetText(Translate("BATTLEGROUND_INSTANCE"));
PVPBattlegroundFrameCancelButton:SetText(Translate("CANCEL"));
PVPBattlegroundFrameJoinButton:SetText(Translate("BATTLEFIELD_JOIN"));
PVPBattlegroundFrameGroupJoinButton:SetText(Translate("BATTLEFIELD_GROUP_JOIN"));

--PVPFrame.xml

--PVPFramePortrait:SetText(Translate("PLAYER_V_PLAYER"));
--PVPFramePortraitBackgroundBlackFilterOffSeasonText:SetText(Translate("CANHAZDUMMYTEXT"));
--PVPFramePortraitBackgroundBlackFilterOffSeasonHonorLabel:SetText(Translate("PVP_LABEL_HONOR"));
--PVPFramePortraitBackgroundBlackFilterOffSeasonHonorPoints:SetText(Translate("12,123,213"));
PVPFrameArenaLabel:SetText(Translate("PVP_LABEL_ARENA"));
--PVPFrameArenaPoints:SetText(Translate("12,123,213"));
PVPHonorKillsLabel:SetText(Translate("KILLS_PVP"));
PVPHonorHonorLabel:SetText(Translate("HONOR"));
PVPHonorTodayLabel:SetText(Translate("HONOR_TODAY"));
PVPHonorYesterdayLabel:SetText(Translate("HONOR_YESTERDAY"));
PVPHonorLifetimeLabel:SetText(Translate("HONOR_LIFETIME"));
--PVPHonorLifetimeHonor:SetText(Translate("-"));
--PVPTeam3ToggleButtonToggleButton:SetText(Translate("Show Season Stats"));
PVPTeamDetailsGamesLabel:SetText(Translate("GAMES"));
PVPTeamDetailsGames:SetText(Translate("45"));
PVPTeamDetailsWinLossLabel:SetText(Translate("WIN_LOSS"));
PVPTeamDetailsRankLabel:SetText(Translate("RANK"));
PVPTeamDetailsRatingLabel:SetText(Translate("ARENA_TEAM_RATING"));
PVPTeamDetailsFrameColumnHeader1:SetText(Translate("NAME"));
PVPTeamDetailsFrameColumnHeader2:SetText(Translate("CLASS"));
PVPTeamDetailsFrameColumnHeader3:SetText(Translate("PLAYED"));
PVPTeamDetailsFrameColumnHeader4:SetText(Translate("WIN_LOSS"));
PVPTeamDetailsFrameColumnHeader5:SetText(Translate("RATING"));
PVPTeamDetailsAddTeamMember:SetText(Translate("ADDMEMBER_TEAM"));
PVPParentFrameTab1:SetText(Translate("PVP"));
PVPParentFrameTab2:SetText(Translate("BATTLEGROUNDS"));

--PVPFrameTemplates.xml

--PVPTeamDataTemplateRatingLabel:SetText(Translate("ARENA_TEAM_RATING"));
--PVPTeamDataTemplateTypeLabel:SetText(Translate("ARENA_THIS_WEEK"));
--PVPTeamDataTemplateGamesLabel:SetText(Translate("GAMES"));
--PVPTeamDataTemplateWinLossLabel:SetText(Translate("WIN_LOSS"));
--PVPTeamDataTemplatePlayedLabel:SetText(Translate("PLAYED"));

--PaperDollFrame.xml

CharacterLevelText:SetText(Translate("Level level race class"));
CharacterTitleText:SetText(Translate("title of the player"));
MagicResText1:SetText(Translate("X"));
MagicResText2:SetText(Translate("X"));
MagicResText3:SetText(Translate("X"));
MagicResText4:SetText(Translate("X"));
MagicResText5:SetText(Translate("X"));
GearManagerDialogDeleteSet:SetText(Translate("DELETE"));
GearManagerDialogEquipSet:SetText(Translate("EQUIPSET_EQUIP"));
GearManagerDialogSaveSet:SetText(Translate("SAVE"));
--SetContainerDeleteSetEquipSetSaveSetPopupPopup:SetText(Translate("GEARSETS_POPUP_TEXT"));
--SetContainerDeleteSetEquipSetSaveSetPopupPopup:SetText(Translate("MACRO_POPUP_CHOOSE_ICON"));
--SetContainerDeleteSetEquipSetSaveSetPopupCancel:SetText(Translate("CANCEL"));
--SetContainerDeleteSetEquipSetSaveSetPopupOkay:SetText(Translate("OKAY"));

--PartyFrame.xml


--PartyFrameTemplates.xml


--PetActionBarFrame.xml


--PetFrame.xml


--PetPaperDollFrame.xml

PetLevelText:SetText(Translate("Level level race class"));
PetPaperDollCloseButton:SetText(Translate("CLOSE"));
PetMagicResText1:SetText(Translate("X"));
PetMagicResText2:SetText(Translate("X"));
PetMagicResText3:SetText(Translate("X"));
PetMagicResText4:SetText(Translate("X"));
PetMagicResText5:SetText(Translate("X"));
CompanionSummonButton:SetText(Translate("SUMMON"));
PetPaperDollFrameTab1:SetText(Translate("PET"));
PetPaperDollFrameTab2:SetText(Translate("COMPANIONS"));
PetPaperDollFrameTab3:SetText(Translate("MOUNTS"));

--PetPopup.xml

--PetRenamePopup:SetText(Translate("PET_RENAME_LABEL"));
--PetRenamePopupAcceptButton:SetText(Translate("ACCEPT"));
--PetRenamePopupCancelButton:SetText(Translate("CANCEL"));

--PetStable.xml

PetStableTitleLabel:SetText(Translate("STABLES"));
PetStableLevelText:SetText(Translate("Bobby The Fleshripper (Level 99 Raptor)"));
PetStableSlotText:SetText(Translate("STABLE_SLOT_TEXT"));
PetStableCostLabel:SetText(Translate("COSTS_LABEL"));
PetStableCurrentPet:SetText(Translate("CURRENT_PET"));
PetStableStabledPet2:SetText(Translate("STABLED_PETS"));
PetStablePurchaseButton:SetText(Translate("PURCHASE"));

--PetitionFrame.xml

PetitionFrameMemberTitle:SetText(Translate("MEMBERS"));
PetitionFrameCancelButton:SetText(Translate("CLOSE"));
PetitionFrameSignButton:SetText(Translate("SIGN_CHARTER"));
PetitionFrameRequestButton:SetText(Translate("REQUEST_SIGNATURE"));
PetitionFrameRenameButton:SetText(Translate("RENAME_GUILD"));

--PlayerFrame.xml


--QuestFrame.xml

QuestFrameNpcNameText:SetText(Translate("Title Text"));
QuestFrameCancelButton:SetText(Translate("CANCEL"));
QuestFrameCompleteQuestButton:SetText(Translate("COMPLETE_QUEST"));
QuestRewardRewardTitleText:SetText(Translate("QUEST_REWARDS"));
QuestRewardItemChooseText:SetText(Translate("REWARD_CHOOSE"));
QuestFrameGoodbyeButton:SetText(Translate("CANCEL"));
QuestFrameCompleteButton:SetText(Translate("CONTINUE"));
QuestProgressTitleText:SetText(Translate("Quest Title"));
QuestProgressRequiredItemsText:SetText(Translate("TURN_IN_ITEMS"));
QuestProgressRequiredMoneyText:SetText(Translate("REQUIRED_MONEY"));
QuestFrameDeclineButton:SetText(Translate("DECLINE"));
QuestFrameAcceptButton:SetText(Translate("ACCEPT"));
QuestDetailObjectiveTitleText:SetText(Translate("QUEST_OBJECTIVES"));
QuestDetailRewardTitleText:SetText(Translate("QUEST_REWARDS"));
QuestDetailItemChooseText:SetText(Translate("REWARD_CHOICES"));
QuestDetailItemReceiveText:SetText(Translate("Reward receive text"));
QuestFrameGreetingGoodbyeButton:SetText(Translate("GOODBYE"));
GreetingText:SetText(Translate("Filler Text"));
CurrentQuestsText:SetText(Translate("CURRENT_QUESTS"));
AvailableQuestsText:SetText(Translate("AVAILABLE_QUESTS"));

--QuestFrameTemplates.xml

--QuestHonorFrameTemplateHonorReceiveText:SetText(Translate("BONUS_HONOR"));
--QuestTalentFrameTemplateTalentReceiveText:SetText(Translate("BONUS_TALENTS"));
--QuestPlayerTitleFrameTemplateTitleLabel:SetText(Translate("REWARD_TITLE"));

--QuestLogFrame.xml

QuestLogFrameAbandonButton:SetText(Translate("ABANDON_QUEST_ABBREV"));
QuestLogFrameTrackButton:SetText(Translate("TRACK_QUEST_ABBREV"));
QuestLogFramePushQuestButton:SetText(Translate("SHARE_QUEST_ABBREV"));
QuestLogDetailTitleText:SetText(Translate("QUEST_DETAILS"));
QuestLogQuestTitle:SetText(Translate("Quest title"));
QuestLogRequiredMoneyText:SetText(Translate("REQUIRED_MONEY"));
QuestLogDescriptionTitle:SetText(Translate("QUEST_DESCRIPTION"));
QuestLogRewardTitleText:SetText(Translate("QUEST_REWARDS"));
QuestLogItemChooseText:SetText(Translate("REWARD_CHOICES"));
QuestLogTitleText:SetText(Translate("QUEST_LOG"));
QuestLogFrameCancelButton:SetText(Translate("CLOSE"));
QuestLogFrameShowMapButtonText:SetText(Translate("SHOW_MAP"));
QuestLogNoQuestsText:SetText(Translate("QUESTLOG_NO_QUESTS_TEXT"));

--QuestTimerFrame.xml

--QuestTimerHeader:SetText(Translate("QUEST_TIMERS"));

--RaidFrame.xml

--RaidInfoHeaderTemplateMiddle:SetText(Translate("TEST"));
--RaidInfoInstanceTemplateExtended:SetText(Translate("EXTENDED"));
RaidFrameRaidDescription:SetText(Translate("RAID_DESCRIPTION"));
RaidFrameConvertToRaidButton:SetText(Translate("CONVERT_TO_RAID"));
RaidFrameRaidInfoButton:SetText(Translate("RAID_INFO"));
RaidInfoFrameHeaderText:SetText(Translate("RAID_INFORMATION"));
RaidInfoExtendButton:SetText(Translate("EXTEND_RAID_LOCK"));
RaidInfoCancelButton:SetText(Translate("CLOSE"));

--RaidWarning.xml


--RatingMenuFrame.xml

--RatingMenuFrameHeader:SetText(Translate("RATINGS_MENU"));
RatingMenuFrameText:SetText(Translate("RATINGS_TEXT"));
RatingMenuButtonOkay:SetText(Translate("OKAY"));

--ReadyCheck.xml

ReadyCheckFrameYesButton:SetText(Translate("YES"));
ReadyCheckFrameNoButton:SetText(Translate("NO"));

--ReputationFrame.xml

--ReputationBarTemplateExpandOrCollapseButtonHighlightReputationBarFactionStanding:SetText(Translate("Revered"));
ReputationFrameFactionLabel:SetText(Translate("FACTION"));
ReputationFrameStandingLabel:SetText(Translate("STANDING"));

--RuneFrame.xml


--SecureHandlerTemplates.xml


--SecureTemplates.xml


--SkillFrame.xml

SkillFrameCancelButton:SetText(Translate("CLOSE"));

--SparkleFrame.xml


--SpellBookFrame.xml

SpellBookTitleText:SetText(Translate("SPELLBOOK"));
SpellBookPrevPageButton:SetText(Translate("PREV"));
SpellBookNextPageButton:SetText(Translate("NEXT"));

--StackSplitFrame.xml

StackSplitOkayButton:SetText(Translate("OKAY"));
StackSplitCancelButton:SetText(Translate("CANCEL"));

--StaticPopup.xml


--StatsFrame.xml


--TabardFrame.xml

TabardFrameGreetingText:SetText(Translate("TABARDVENDORGREETING"));
TabardFrameCostLabel:SetText(Translate("TABARDVENDORCOST"));
TabardFrameAcceptButton:SetText(Translate("ACCEPT"));
TabardFrameCancelButton:SetText(Translate("CANCEL"));

--TalentFrameTemplates.xml


--TargetFrame.xml

TargetDeadText:SetText(Translate("DEAD"));
TargetFrameNumericalThreatValue:SetText(Translate("100%"));
TargetofTargetDeadText:SetText(Translate("DEAD"));

--TaxiFrame.xml


--TextStatusBar.xml


--TicTacToeFrame.xml

--TicTacToeFrameTitleText:SetText(Translate("DRESSUP_FRAME"));
--TicTacToeFrameDescriptionText:SetText(Translate("DRESSUP_FRAME_INSTRUCTIONS"));

--TotemFrame.xml


--TradeFrame.xml

--TradeItemTemplateName:SetText(Translate("Item Name"));
TradeFrameRecipientNameText:SetText(Translate("Player Name"));
TradeFramePlayerNameText:SetText(Translate("Recipient Name"));
TradeFramePlayerEnchantText:SetText(Translate("TRADEFRAME_ENCHANT_SLOT_LABEL"));
TradeFrameRecipientEnchantText:SetText(Translate("TRADEFRAME_ENCHANT_SLOT_LABEL"));
TradeFrameTradeButton:SetText(Translate("TRADE"));
TradeFrameTradeButton:SetText(Translate("TRADE"));
TradeFrameCancelButton:SetText(Translate("CANCEL"));
TradeFrameCancelButton:SetText(Translate("CANCEL"));

--TutorialFrame.xml

TutorialFrameCheckboxText:SetText(Translate("ENABLE_TUTORIAL_TEXT"));
TutorialFrameOkayButton:SetText(Translate("OKAY"));

--UIDropDownMenu.xml


--UIDropDownMenuTemplates.xml


--UIErrorsFrame.xml


--UIMenu.xml


--UIPanelTemplates.xml


--UIParent.xml


--UnitFrame.xml


--UnitPopup.xml


--VehicleMenuBar.xml


--VideoOptionsFrame.xml

VideoOptionsFrameApply:SetText(Translate("APPLY"));
VideoOptionsFrameCancel:SetText(Translate("CANCEL"));
VideoOptionsFrameOkay:SetText(Translate("OKAY"));
VideoOptionsFrameDefaults:SetText(Translate("DEFAULTS"));

--VideoOptionsPanels.xml

VideoOptionsResolutionPanelTitle:SetText(Translate("RESOLUTION_LABEL"));
VideoOptionsResolutionPanelSubText:SetText(Translate("RESOLUTION_SUBTEXT"));
--VideoOptionsResolutionPanelTitleSubTextResolutionDropDownLabel:SetText(Translate("RESOLUTION"));
--VideoOptionsResolutionPanelTitleSubTextResolutionDropDownRefreshDropDownLabel:SetText(Translate("REFRESH_RATE"));
--VideoOptionsResolutionPanelTitleSubTextResolutionDropDownRefreshDropDownMultiSampleDropDownLabel:SetText(Translate("MULTISAMPLE"));
VideoOptionsEffectsPanelTitle:SetText(Translate("EFFECTS_LABEL"));
VideoOptionsEffectsPanelSubText:SetText(Translate("EFFECTS_SUBTEXT"));
--VideoOptionsEffectsPanelTitleSubTextQualityLabel:SetText(Translate("LOW"));
--VideoOptionsEffectsPanelTitleSubTextQualitySubText:SetText(Translate("This is a description of what happens when you set the quality slider to its Low setting."));
--VideoOptionsEffectsPanelTitleSubTextQualityQualitySliderCustom:SetText(Translate("CUSTOM"));
VideoOptionsStereoPanelTitle:SetText(Translate("STEREO_VIDEO_LABEL"));
VideoOptionsStereoPanelSubText:SetText(Translate("STEREO_VIDEO_SUBTEXT"));

--VoiceChat.xml


--WatchFrame.xml

--AchievementProgressBarTemplateText:SetText(Translate("700/700"));
--WatchFrameItemButtonTemplateHotKey:SetText(Translate("RANGE_INDICATOR"));
WatchFrameTitle:SetText(Translate("OBJECTIVES_TRACKER_LABEL"));

--WorldFrame.xml

FramerateLabel:SetText(Translate("FRAMERATE_LABEL"));

--WorldMapFrame.xml

--WorldMapFrameTexture12:SetText(Translate("WORLD_MAP"));
--WorldMapZoneMinimapDropDown:SetText(Translate("BATTLEFIELD_MINIMAP"));
--WorldMapContinentDropDown:SetText(Translate("CONTINENT"));
--WorldMapZoneDropDown:SetText(Translate("ZONE"));
WorldMapZoomOutButton:SetText(Translate("ZOOM_OUT"));
--WorldMapLevelDropDown:SetText(Translate("FLOOR"));
WorldMapMagnifyingGlassButton:SetText(Translate("ZOOM_OUT_BUTTON_TEXT"));
MapFramerateLabel:SetText(Translate("FRAMERATE_LABEL"));
WorldMapFrameAreaLabel:SetText(Translate("BLAH!"));

--WorldMapFrameTemplates.xml


--WorldStateFrame.xml

WorldStateScoreFrameLabel:SetText(Translate("BATTLEFIELDS"));
WorldStateScoreFrameTimerLabel:SetText(Translate("TIME_TO_PORT"));
WorldStateScoreFrameTab1:SetText(Translate("ALL"));
WorldStateScoreFrameTab2:SetText(Translate("FACTION_ALLIANCE"));
WorldStateScoreFrameTab3:SetText(Translate("FACTION_HORDE"));
WorldStateScoreFrameLeaveButton:SetText(Translate("LEAVE_BATTLEGROUND"));

--ZoneText.xml
