<?php

class PageImport extends Page
{
  function ShowInstructions()
  {
    $Output = '<div>'.
    '<h5>Návod:</h5>'.
    '<ol><li>Připojíme se přes SSH na server (wowpreklad.zdechov.net) například přes program putty.exe nebo terminál v linuxu.</li>'.
    '<li>Nejprve je potřeba získat zdrojová data. Není zapotřebí mít všechny typy textu.'.

    '<ol style="list-style-type: lower-alpha">'.
    '<li>SQL databázi UDB seženeme na fóru: http://udbforums.kicks-ass.net/index.php?board=5.0 , soubor rozbalíme a uložíme do adresáře "wowpreklad/source/cislo_verze/sql/"</li>'.
    '<li>DBC soubory exportujeme přímo ze hry z souboru "World of Warcraft\Data\enGB\patch-enGB-2.MPQ" nebo z souboru s vyšším číslem na konci. Export se provádí například pomocí programu "MPQEditor.exe", který je ke stažení v adresáři "wowpreklad/download". DBC soubory jsou v MPQ souboru uloženy ve složce "DBFilesClient". Tyto soubory zkopírujte do složky "wowpreklad/source/císlo_verze/dbc/"</li>'.
    '<li>LUA soubory exportujeme přímo ze hry ze souboru "World of Warcraft\Data\enGB\patch-enGB-2.MPQ" nebo ze souboru s vyšším číslem na konci. Export se provádí například pomocí programu "MPQEditor.exe", který je ke stažení v adresáři "wowpreklad/download". LUA soubory jsou v MPQ souboru uloženy ve složce "Interface\FrameXML" a složce "Interface\GlueXML". Soubory, které potřebujeme se jmenují "GlobalString.lua" a "GlueString.lua". Tyto soubory zkopírujte do složky "wowpreklad/source/císlo_verze/lua/"</li></ol></li>'.
    '<li>Do databáze vložíme data o verzi, kterou se hodláme importovat do tabulky wow_client_verse. Pokud budeme importovat dbc soubory je nutné vložit zde strukturu dbc souboru. To lze provést například pomocí programu "CBCUtil", který je také ke stažení v složce download. Tento program vytvoří soubory spustitelné v LibreOffice. Kde první řádek v tabulce je struktura dbc souboru. Typ "str" se zaznačí jako "s", každý jiný typ se označí písmenem "u". Struktura pak vypadá například "usuuuuuuuuuuuu". Kromě toho je zapotřebí do databáze poznačit číselné pozice textu, první položka je 0. Z předchozího příkladu by pozice sloupce s textem byla 1.</li>'.
    '<li>V nastavení "wowpreklad/Config/Config.php" nastavíme nejvyšší verzi na verzi, kterou hodláme importovat.</li>'.
    '<li>Až máme všechno připraveno spustíme v konzoli script příkazem "php wowpreklad/import/cmd.php", kde jsou popsané možnosti paremetru, se kterýma se tento skript spouští pro ruzné importy.</li>'.
    '<li>Po provedení importu je potřeba několikrát spustit skript na aktualizaci verze u překladu. Je potřeba ho provádět opakovaně dokud nezmizí tečky označující, že byly provedeny změny.</li>'.
    '</ol>';
    return($Output);
  }

  function ShowImportGroup()
  {
    global $System;

    if(array_key_exists('id', $_GET))
    {
      $Output = '<div style="font-size: xx-small;">';

      $GroupId = (int)$_GET['id'];
      $Import = new Import($System);
      $Import->SetVersion($System->Config['Web']['GameVersion']);
      $Output .= $Import->ImportGroup($GroupId);

      $this->System->ModuleManager->Modules['Log']->WriteLog('Plnění databáze', LOG_TYPE_MODERATOR);
      $Output .= '</div>';
    } else $Output = ShowMessage('Nebylo zadáno id skupiny.', MESSAGE_CRITICAL);
    return($Output);
  }

  function ShowMenu()
  {
    $TranslationTree = $this->System->ModuleManager->Modules['Translation']->GetTranslationTree();
    $Output = '<strong>Import zdrojů:</strong><br/>'.
      '<a href="?action=instructions">Instrukce pro přípravu zdrojových souborů</a><br/>'.
      '<a href="?action=update_translated">Zaktualizovat verze přeložených</a><br/><br/>'.
      'Verze klienta použitá pro import: <strong>'.$this->System->Config['Web']['GameVersion'].'</strong><br/>';
    $DbResult = $this->System->Database->query('SELECT COUNT(*) FROM `Group`');
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);
    $Output .= '<h3>Seznam překladových skupin</h3>';
    $Output .= $PageList['Output'];

    $Output .= '<table class="BaseTable">';
    $TableColumns = array(
      array('Name' => 'Name', 'Title' => 'Jméno'),
      array('Name' => 'SourceType', 'Title' => 'Typ zdroje'),
      array('Name' => 'SourceName', 'Title' => 'Jméno zdroje'),
      array('Name' => 'LastImport', 'Title' => 'Datum'),
      array('Name' => 'LastVersion', 'Title' => 'Verze'),
      array('Name' => '', 'Title' => 'Akce'),
    );

    $Order = GetOrderTableHeader($TableColumns, 'Name', 0);
    $Output .= $Order['Output'];

    $DbResult = $this->System->Database->query('SELECT * FROM `Group`'.$Order['SQL'].$PageList['SQLLimit']);
    while($Group = $DbResult->fetch_assoc())
    {
      $Output .= '<tr><td>'.T($Group['Name']).'</td>'.
        '<td>'.$Group['SourceType'].'</td><td>';
      if($Group['MangosTable'] != '') $Output .= $Group['MangosTable'].'.sql ';
      if($Group['DBCFileName'] != '') $Output .= $Group['DBCFileName'].'.dbc ';
      if($Group['LuaFileName'] != '') $Output .= $Group['LuaFileName'].'.lua ';
      $Output .= '</td>'.
        '<td><a title="Změny po posledním importu u vybrané překladové skupiny" href="../log/?group='.$Group['Id'].'&amp;type=11">'.HumanDate($Group['LastImport']).'</a></td>'.
        '<td><a href="'.$this->System->Link('/client-version/?action=item&amp;id='.
        GetVersionWOWId($Group['LastVersion'])).'">'.GetVersionWOW($Group['LastVersion']).'</a></td>'.
        '<td><a href="?action=importgroup&amp;id='.$Group['Id'].'">Importovat</a></td></tr>';
    }
    $Output .= '</table>';
    return($Output);
  }

  function UpdateTranslated()
  {
    global $System;

    $Output = '<div style="font-size: xx-small;">';
    $Import = new Import($System);
    $Output .= $Import->UpdateTranslated();
    $Output .= '</div>';
    return($Output);
  }

  function Show()
  {
    $this->Title = T('Import');
    $Output = '';
    if($this->System->User->Licence(LICENCE_ADMIN))
    {
    if(array_key_exists('action', $_GET))
    {
      if($_GET['action'] == 'instructions') $Output .= $this->ShowInstructions();
      else if($_GET['action'] == 'importgroup') $Output .= $this->ShowImportGroup();
      else if($_GET['action'] == 'update_translated') $Output .= $this->UpdateTranslated();
      else $Output .= $this->ShowMenu();
    } else $Output .= $this->ShowMenu();
    } else $Output .= ShowMessage(T('Access denied'), MESSAGE_CRITICAL);
    return($Output);
  }
}
