<?php

class ModuleRedirection extends AppModule
{
  function __construct(System $System)
  {
    parent::__construct($System);
    $this->Name = 'Redirection';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Redirects erlier obsolete addresses to new ones.';
    $this->Dependencies = array();
    $this->Excludes = array();
  }

  function DoStart()
  {
    $this->System->OnPageNotFound = array($this, 'ShowRedirect');
  }

  function Redirect($Location)
  {
    Header($_SERVER['SERVER_PROTOCOL'].' 301 Moved Permanently');
    Header('Location: '.$Location);
    return('<h3 align="center">'.T('').'</h3>');
  }

  function ShowRedirect()
  {
    $Output = '';
    if(count($this->System->PathItems) > 0)
    {
      if($this->System->PathItems[0] == 'user.php') $Output = $this->Redirect($this->System->Link('/user/'));
      if($this->System->PathItems[0] == 'team.php') $Output = $this->Redirect($this->System->Link('/team/'));
      if($this->System->PathItems[0] == 'version.php') $Output = $this->Redirect($this->System->Link('/client-version/'));
      if($this->System->PathItems[0] == 'phpBB3') $Output = $this->Redirect($this->System->Link('/forum/'));
      if($this->System->PathItems[0] == 'phpbb3') $Output = $this->Redirect($this->System->Link('/forum/'));
      if($this->System->PathItems[0] == 'statistic.php') $Output = $this->Redirect($this->System->Link('/progress/'));
      if($this->System->PathItems[0] == 'register.php') $Output = $this->Redirect($this->System->Link('/registration/'));
      if($this->System->PathItems[0] == 'registrace.php') $Output = $this->Redirect($this->System->Link('/registration/'));
      if($this->System->PathItems[0] == 'dictionary.php') $Output = $this->Redirect($this->System->Link('/dictionary/'));
      if($this->System->PathItems[0] == 'download-addon.php') $Output = $this->Redirect($this->System->Link('/download/'));
      if($this->System->PathItems[0] == 'banners.php') $Output = $this->Redirect($this->System->Link('/referrer/'));
      if($this->System->PathItems[0] == 'download.php') $Output = $this->Redirect($this->System->Link('/download/'));
      if($this->System->PathItems[0] == 'serverlist.php') $Output = $this->Redirect($this->System->Link('/server/'));
      if($this->System->PathItems[0] == 'info.php') $Output = $this->Redirect($this->System->Link('/info/'));
      if($this->System->PathItems[0] == 'userlist.php') $Output = $this->Redirect($this->System->Link('/users/'));
      if($this->System->PathItems[0] == 'promotion.php') $Output = $this->Redirect($this->System->Link('/promotion/'));
      if($this->System->PathItems[0] == 'log.php') $Output = $this->Redirect($this->System->Link('/log/'));
      if(count($this->System->PathItems) > 1)
      {
        if(($this->System->PathItems[0] == 'team') and ($this->System->PathItems[1] == 'userlist.php'))
          $Output = $this->Redirect($this->System->Link('/userlist/'));
        if(($this->System->PathItems[0] == 'dictionary') and ($this->System->PathItems[1] == 'user.php'))
          $Output = $this->Redirect($this->System->Link('/user/'));
        if(($this->System->PathItems[0] == 'forum') and ($this->System->PathItems[1] == 'index.php'))
          $Output = $this->Redirect($this->System->Link('/forum/'));
        if(($this->System->PathItems[0] == 'phpbb3') and ($this->System->PathItems[1] == 'index.php'))
          $Output = $this->Redirect($this->System->Link('/forum/'));
        if(($this->System->PathItems[0] == 'phpBB3') and ($this->System->PathItems[1] == 'index.php'))
          $Output = $this->Redirect($this->System->Link('/forum/'));
        if(($this->System->PathItems[0] == 'download') and ($this->System->PathItems[1] == 'ceske_fonty_do_wow.zip'))
          $Output = $this->Redirect($this->System->Link('/files/ceske_fonty_do_wow.zip'));
      }
    }
    return($Output);
  }
}
