<?php

class PageUserList extends Page
{
  function Show()
  {
    $this->Title = T('Translators');
    $Output = '';
    if(array_key_exists('search', $_GET)) $_SESSION['search'] = $_GET['search'];
    else if(!array_key_exists('search', $_SESSION)) $_SESSION['search'] = '';
    if(array_key_exists('search', $_GET) and ($_GET['search'] == '')) $_SESSION['search'] = '';
    if($_SESSION['search'] != '')
    {
      $SearchQuery = ' AND (`User`.`Name` LIKE "%'.$_SESSION['search'].'%")';
      $Output .= '<div><a href="?search=">'.sprintf(T('Disable filter "%s"'), $_SESSION['search']).'</a></div>';
    } else $SearchQuery = '';

    $TeamFilter = '';
    if(array_key_exists('team', $_GET))
    {
      $TeamId = $_GET['team'] * 1;
      $DbResult = $this->Database->select('Team', 'Name', '`Id`='.$TeamId);
      if($DbResult->num_rows > 0)
      {
        $Team = $DbResult->fetch_assoc();
        $Output .= '<h3>'.sprintf(T('Users in team %s'), htmlspecialchars($Team['Name'])).'</h3>';
        $TeamFilter = ' AND (`Team`='.$_GET['team'].')';
      } else {
        $Output .= ShowMessage(sprintf(T('Team %d not found'), $TeamId), MESSAGE_CRITICAL);
      }
    } else
    {
      $Output .= '<h3>'.T('User list').'</h3>';
    }

    $DbResult = $this->Database->query('SELECT COUNT(*) FROM `User` WHERE 1'.$SearchQuery.$TeamFilter);
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);

    $Output .= $PageList['Output'].
    '<table class="BaseTable">';

    $TableColumns = array(
      array('Name' => 'Name', 'Title' => T('Name')),
      array('Name' => 'TranslatedCount', 'Title' => T('Translated count')),
      array('Name' => 'XP', 'Title' => T('Level')),
      array('Name' => 'XP', 'Title' => T('Experience')),
      array('Name' => 'LastLogin', 'Title' => T('Last logged in')),
      array('Name' => 'RegistrationTime', 'Title' => T('Registration time')),
    );
    $Order = GetOrderTableHeader($TableColumns, 'TranslatedCount', 1);
    $Output .= $Order['Output'];

    $Query = 'SELECT `User`.`ID`, `User`.`Name`, `LastLogin`, `GM`, `XP`, `TranslatedCount`, `RegistrationTime` '.
      'FROM `User` '.
      'LEFT JOIN `UserTrace` ON `UserTrace`.`User` = `User`.`Id` '.
      'WHERE 1'.$SearchQuery.$TeamFilter.$Order['SQL'].$PageList['SQLLimit'];

    $DbResult = $this->Database->query($Query);
    while($Line = $DbResult->fetch_assoc())
    {
      $XP = GetLevelMinMax($Line['XP']);
      $Output .= '<tr><td><a href="'.$this->System->Link('/user/?user='.$Line['ID']).'">'.$Line['Name'].'</a></td>'.
        '<td style="text-align: center;"><a href="'.$this->System->Link('/TranslationList.php?user='.$Line['ID'].'&amp;group=0&amp;state=2').'" title="Zobrazit Všechny jeho přeložené texty">'.$Line['TranslatedCount'].'</a></td>'.
        '<td>'.$XP['Level'].'</td>'.
        '<td>'.ProgressBar(150, round($XP['XP'] / $XP['MaxXP'] * 100, 2), $XP['XP'].' / '.$XP['MaxXP']).'</td>'.
        '<td>'.HumanDate($Line['LastLogin']).'</td>'.
        '<td>'.HumanDate($Line['RegistrationTime']).'</td></tr>';
    }
    $Output .= '</table>'.
        $PageList['Output'];

    return($Output);
  }
}
